var mdSmart = mdSmart || {};
/*
 * 空气净化器通信协议
 * @doc WIFI模块与家电设备通信协议（净化器版-20140822-v1.0).doc
 * 2015-03-11:增加水离子与喇叭控制，以及滤网时间采集
 * 变量：waterIon:水离子
		beepFlag:喇叭声音
		beepValue:音量控制
    函数：
        setBeepvalue:function(p1):音量控制
        setBeepflag:function(p1):喇叭声音
        setWaterion:function(p1):水离子
 *  *2015-04-08:增加支持新控制协议，新控制协议支持：
 * 喇叭声音种类选择:loudspeeaerType;以数组表示，长度1位
 * pm2.5数值显示开关:pm25showSwitch;以数组表示，长度1位
 * 负离子间歇控制:anionStart;以数组表示，1位
 * 负离子控制开启关闭时间:anionTimeCount;以数组表示，长度4位
 * 
 * 无级风速选择开关:smartWindSwitch;以数组表示，长度1位
 * 离家模式开关:braceLetContralAwaySwitch;以数组表示，长度1位
 * 回家模式开关:braceLetContralComeSwitch;以数组表示，长度1位
 * 预冷预热开关:readyColdOrHotSwitch;以数组表示，长度1位
 * 手环与舒睡联动:braceLetSleepSwitch;以数组表示，长度1位        
 */
mdSmart.msg0xFC = function(){
	var _messageBodyControl = undefined,_messageBodyRequestStatus = undefined;
	var _equipmentReturnCommandBack = undefined;
	var _messageBodyCheckType = undefined;			// 2015-03-09
	
	var devType = 0xFC;	//设定为除湿机,fc：净化器；fd：加湿器
	var frameCumulative = 1;
	(function init(){
		_messageBodyControl = mdSmart.message.createMessageBody(23);
		_messageBodyRequestStatus = mdSmart.message.createMessageBody(22);
		// 增加查询机型功能  2015-03-09
	    _messageBodyCheckType = mdSmart.message.createMessageBody(1);//查询机型
	}());
	var _status = {
		byte1Bit7:{name:"byte1Bit7(预留)",value:0x00},
		keyState:{name:"按键状态",value:0x00,view:{0:"无键",1:"有键"}},
		fastCheckStatus:{name:"快检状态",value:0x00},
		timeingMode:{name:"定时方式",value:0x00,view:{0:"相对定时"}},
		byte1Bit3:{name:"byte1Bit3(预留)",value:0x00,view:{0:"关闭",1:"开启"}},
		byte1Bit2:{name:"byte1Bit2(预留)",value:0x00},
		remoteControlCodeSource:{name:"遥控码来源",value:0x00,view:{0:"遥控器",1:"移动终端"}},
		runningState:{name:"运行状态",value:0x00,view:{0:"关机",1:"开机"}},
		settingMode1:{name:"净化器设定模式",value:0x00,view:{0:"无效",1:"自动",2:"手动",3:"睡眠"}},  
		settingMode2:{name:"除湿机模式",value:0x00,view:{0:"无效",1:"设定除湿",2:"连续除湿",3:"自动除湿",4:"干衣除湿"}},

		mobileTerminalTimingInfoSwitch:{name:"移动终端定时信息",value:0x00,view:{0:"无效",1:"有效"}},
		noPolarWindSpeedValue:{name:"无极风速值",value:0x00,view:{0:"无效",101:"固定风",102:"自动风",80:"高风",60:"中风",40:"低风",20:"静音风"}},
		timingOpen:{name:"定时开",value:0x00,view:{0:"关",1:"开"}},
		timingOpenAbsoluteHours:{name:"定时开－绝对小时",value:0x00},
		timingOpenAbsoluteMinutes:{name:"定时开－绝对分",value:0x00},
		timingClose:{name:"定时关",value:0x00,view:{0:"关",1:"开"}},
		timingCloseAbsoluteHours:{name:"定时关－绝对小时",value:0x00},
		timingCloseAbsoluteMinutes:{name:"定时关－绝对分",value:0x00},
		//byte7Bit7:{name:"byte7Bit7(预留)",value:0x00},
		setHumidity:{name:"设定湿度",value:0x00,view:{0:"无效",1:"设定湿度1%",99:"设定湿度为99%"}},
		setHumidityPoint:{name:"湿度的小数点",value:0x00},
		strainerAlarm:{name:"滤网提示",value:0x00,view:{0:"关",1:"开"}},
		anion:{name:"负离子",value:0x00,view:{0:"关",1:"开"}},
		comfortSleep:{name:"舒睡",value:0x00,view:{0:"关",1:"开"}},
		waterPumpControlEffectiveNess:{name:"水泵控制是否有效",value:0x00,view:{0:"关",1:"开"}},
		waterPumpControl:{name:"水泵控制",value:0x00,view:{0:"关",1:"开"}},
		screenDisplay:{name:"屏显功能(预留)",value:0x00,view:{0:"数显开启最亮 100%",1:"显示屏亮二档度80%",2:"显示屏亮三档度60%",3:"显示屏亮四档度50%",4:"显示屏亮五档度40%",5:"显示屏亮六档度30%",6:"显示屏亮七档度20%",7:"显示屏亮关闭"}},

		defrosting:{name:"化霜",value:0x00,view:{0:"化霜关闭",2:"化霜开启"}},
		waterState:{name:"水箱状态",value:0x00,view:{0:"未满",1:"满"}},
		humidifierModel:{name:"加湿器模式",value:0x00,view:{0:"无效",1:"??",2:"??"}},
		
		dustFullMarkAlarmTime2:{name:"尘满提示时间：N*2个小时",value:0x00},
		byte12Bit6To7:{name:"byte12Bit6To7（预留）",value:0x00},
		smellSensorAirShow:{name:"异味传感器空气显示",value:0x00,view:{0:"000:一档：好",1:"001：二档：好-",2:"010：三档 中",3:"011：四档 中-",4:"100：五档 差+",5:"101：六档 差"}},
		dustSensorAirQuality:{name:"灰尘传感器空气质量",value:0x00,view:{0:"000:一档：好",1:"001：二档：好-",2:"010：三档 中",3:"011：四档 中-",4:"100：五档 差+",5:"101：六档 差"}},
			
		pm2dot5Low:{name:"PM2.5浓度低字节",value:0x00},
		pm2dot5High:{name:"PM2.5浓度高字节",value:0x00},
		smellSensorAD:{name:"异味传感器的AD值",value:0x00},

		currentHumidity:{name:"当前湿度",value:0x00,view:{0xFF:"没有湿度传感器",1:"当前湿度1%",100:"当前湿度为100%"}},
		indoorTemperature:{name:"室内温度(整数),表示方法：温度值 x 2 + 50",value:0x00},
	
		indoorTemperatureT1Decimal:{name:"室内温度T1温度的小数位",value:0x00},
		indoorHumidityDecimal:{name:"室内湿度的小数位",value:0x00,view:{0:"一档",1:"二档",2:"三档",3:"四档",4:"五档",5:"六档"}},
		photosensitiveSensorCurrentLevel:{name:"光敏的亮度等级",value:0x00,view:{0:"一档",1:"二档",2:"三档",3:"四档",4:"五档",5:"六档"}},
		
		photosensitiveSensorAD:{name:"光敏传感器的AD值",value:0x00},
		
		waterIon:{name:"水离子",value:0x00,view:{0:"关",1:"开"}},//2015-03-11
		beepFlag:{name:"喇叭声音",value:0x00,view:{0:"关",1:"开"}},//2015-03-11
		beepValue:{name:"音量控制",value:0xff},//2015-03-11
		childrenLock:{name:"童锁",value:0x00,view:{0:"关",1:"开"}},//2015-03-11
		
		
		//2015-04-09
 		loudspeeaerType:{name:"喇叭声音种类选择",value:0x00,view:{0:"女声",1:"男声",2:"儿童声",3:"蜂鸣器"}},
        pm25showSwitch:{name:"pm2.5数值显示开关",value:0x00,view:{0:"关",1:"开"}},
        anionStart:{name:"负离子间歇控制",value:0x00,view:{0:"关",1:"开"}},
        anionTimeCount:{name:"负离子控制开启关闭时间",value:0x00},	
        

		faultCode:{name:"故障代码",value:0x00},
		// PM2.5浓度
        getAirQuality:function(){return (this.pm2dot5High.value << 8) | this.pm2dot5Low.value;}
	};
	
	// 解析机型数据   2015-03-09
	function _parseTypeMessage(pReceiveMessage){
		var receiveMessageBody = pReceiveMessage.slice(10,pReceiveMessage.length - 1);
		var messageType = mdSmart.message.getByte(pReceiveMessage,9);
		var deviceType = "-1";
		if(messageType == 0xA0){
			deviceType = mdSmart.message.getBits(receiveMessageBody,2,0,7);	//净化器机型
			//alert("deviceType="+deviceType +" a0message="+receiveMessageBody);
		}
		
		bridge.logToIOS(" fc test type :"+ pReceiveMessage);
	
		return deviceType;
	};
	
	function _parseMessage(pReceiveMessage){
		var receiveMessageBody = pReceiveMessage.slice(10,pReceiveMessage.length - 1);
		var messageType = mdSmart.message.getByte(pReceiveMessage,9);
		var isEquipmentReturnCommandBack = false;
		var isX05Xa1Back=false,isX04Xa0Back=false;
		
	    //2015-04-08
		var isNEWVerBack = false;
		
		//2015-04-08 新协议命令回复处理
		if((receiveMessageBody[0] == 0xB0) || (receiveMessageBody[0] == 0xB1))
		{
			isNEWVerBack =  true;
		}		
		
		if(receiveMessageBody[0] == 0xC8){
			//设备返回命令(设备当前状态返回)
			isEquipmentReturnCommandBack = true;
//			alert("receivemessage="+receiveMessageBody);
		}
//		if(messageType == 0x05){
		if(receiveMessageBody[0] == 0xA1){
				//净化器自动上传命令(0x05)
				//isX05Xa1Back = true;
//				alert("05message="+stringToHex(pReceiveMessage));
		}
//		}
//		if(messageType == 0x04){
			
			//alert("04message="+convertTo16Str(pReceiveMessage));
//			alert("04message="+pReceiveMessage);
		if(receiveMessageBody[0] == 0xA0){
				//除湿机自动上传命令(0x04)
			isX04Xa0Back = true;
			//alert(pReceiveMessage);
		}
//		}
		//设备返回命令(设备当前状态返回)
		if(isEquipmentReturnCommandBack == true){
			_equipmentReturnCommandBack = pReceiveMessage;
			_parseEquipmentReturnCommandBackToStatus(receiveMessageBody);
			_doSynchronousEquipmentReturnCommandBackToCmd(receiveMessageBody);
		}
		//净化器自动上传命令(0x04)
		if(isX04Xa0Back == true){
			_equipmentReturnCommandBack = pReceiveMessage;
			_parseEquipmentReturnCommandBackToStatusA0(receiveMessageBody);
			_doSynchronousEquipmentReturnCommandBackToCmdA0(receiveMessageBody);
		}
		var result = {
			messageType:messageType,
			status:_status
		};
		return result;
	}
	
	//2015-04-08 新协议返回解析	
	function _refreshNewVer(p1,p2){
		alert(p1 +' ' + p2);
		
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			return;
		}
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			
			return;
		}
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			
			return;
		}
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			
			return;
		}
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			
			return;
		}
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			
			return;
		}
		if((p1[0] == 0x02) && (p1[1] == 0x09)){
			
			return;
		}		
	}
	 
	//2015-04-08 新协议返回解析
	function _parseEquipmentReturnCommandBackForNewVer(pReceiveMessageBody){
		var dealCount = pReceiveMessageBody[1];//属性个数
		var si = 0;
		var sj = 0;
		var NewCmdType =[];               //属性命令
		var NewCmdLength = 0;			  //属性长度
		var NewValue =[];				  //属性值
		var sk = 2;
		for(si = 0; si < dealCount; si++){
			NewCmdType[0] = pReceiveMessageBody[sk];
			NewCmdType[1] = pReceiveMessageBody[sk + 1];  //高位
			
			NewCmdLength = pReceiveMessageBody[sk + 3];
			if(pReceiveMessageBody[sk + 2] == 0x00){
				for(sj = 0; sj < NewCmdLength; sj++){
					NewValue[sj] = pReceiveMessageBody[sk + 4 + sj];	
				}
				_refreshNewVer(NewCmdType,NewValue);	
			}		
			else{
				alert('设置失败！');
			}
           sk =  sk + 3 + NewCmdLength + 1 ;
		}
	}		
	
	// 设备返回命令==>_status
	function _parseEquipmentReturnCommandBackToStatus(pReceiveMessageBody){
		_status.byte1Bit7.value = mdSmart.message.getBit(pReceiveMessageBody,1,7);//byte1Bit7(预留)
		_status.keyState.value = mdSmart.message.getBit(pReceiveMessageBody,1,6);//按键状态
		_status.fastCheckStatus.value = mdSmart.message.getBit(pReceiveMessageBody,1,5);//快检状态
		_status.timeingMode.value = mdSmart.message.getBit(pReceiveMessageBody,1,4);//定时方式
		_status.byte1Bit3.value = mdSmart.message.getBit(pReceiveMessageBody,1,3);//byte1Bit3(预留)
		_status.byte1Bit2.value = mdSmart.message.getBit(pReceiveMessageBody,1,2);//byte1Bit2(预留)
		_status.remoteControlCodeSource.value = mdSmart.message.getBit(pReceiveMessageBody,1,1);//遥控码来源
		_status.runningState.value = mdSmart.message.getBit(pReceiveMessageBody,1,0);//运行状态
		_status.settingMode1.value = mdSmart.message.getBits(pReceiveMessageBody,2,4,7);//净化器设定模式
		_status.settingMode2.value = mdSmart.message.getBits(pReceiveMessageBody,2,0,3);//除湿机模式
		//_status.settingTemperatureDot5.value = mdSmart.message.getBit(pReceiveMessageBody,2,4);//0.5
		//_status.settingTemperature.value = mdSmart.message.getBits(pReceiveMessageBody,2,0,3);//设定温度
		_status.mobileTerminalTimingInfoSwitch.value = mdSmart.message.getBit(pReceiveMessageBody,3,7);//移动终端定时信息
		_status.noPolarWindSpeedValue.value = mdSmart.message.getBits(pReceiveMessageBody,3,0,6);//无极风速值
		_status.timingOpen.value = mdSmart.message.getBit(pReceiveMessageBody,4,7);//定时开
		//_status.timingOpenAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,4,2,6);//定时开－绝对小时
		//_status.timingOpenAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,4,0,1) + (mdSmart.message.getBits(pReceiveMessageBody,6,4,7) << 2);//定时开－绝对分
		_status.timingOpenAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,4,0,6);//定时开－绝对小时
		_status.timingOpenAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,6,4,7);//定时开－绝对分
		
		_status.timingClose.value = mdSmart.message.getBit(pReceiveMessageBody,5,7);//定时关
		//_status.timingCloseAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,5,2,6);//定时关－绝对小时
		//_status.timingCloseAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,5,0,1) + (mdSmart.message.getBits(pReceiveMessageBody,6,0,3) << 2);//定时关－绝对分
		_status.timingCloseAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,5,0,6);//定时关－绝对小时
		_status.timingCloseAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,6,0,3);//定时关－绝对分

		_status.setHumidity.value = mdSmart.message.getBits(pReceiveMessageBody,7,0,7);//设定湿度
		_status.setHumidityPoint.value = mdSmart.message.getBits(pReceiveMessageBody,8,0,3);//设定湿度的小数点

		_status.childrenLock.value = mdSmart.message.getBit(pReceiveMessageBody,8,7);//童锁  2015-03-11
		_status.strainerAlarm.value = mdSmart.message.getBit(pReceiveMessageBody,9,7);//滤网提示
		
		_status.anion.value = mdSmart.message.getBit(pReceiveMessageBody,9,6);//负离子
		_status.comfortSleep.value = mdSmart.message.getBit(pReceiveMessageBody,9,5);//舒睡
		_status.waterPumpControlEffectiveNess.value = mdSmart.message.getBit(pReceiveMessageBody,9,4);//水泵控制是否有效
		_status.waterPumpControl.value = mdSmart.message.getBit(pReceiveMessageBody,9,3);//水泵控制
		_status.screenDisplay.value = mdSmart.message.getBits(pReceiveMessageBody,9,0,2);//屏显功能(预留)

		_status.defrosting.value = mdSmart.message.getBit(pReceiveMessageBody,10,7);//化霜
		_status.waterState.value = mdSmart.message.getBit(pReceiveMessageBody,10,6);//水箱状态
		_status.humidifierModel.value = mdSmart.message.getBits(pReceiveMessageBody,8,4,6);//水箱状态

		_status.dustFullMarkAlarmTime2.value = mdSmart.message.getBits(pReceiveMessageBody,11,0,7) * 4 + 
		                                       mdSmart.message.getBits(pReceiveMessageBody,12,6,7);//尘满提示时间：单位小时 2015-03-11
	
		_status.byte12Bit6To7.value = mdSmart.message.getBits(pReceiveMessageBody,12,6,7);//byte12Bit6To7（预留）
		
		_status.smellSensorAirShow.value = mdSmart.message.getBits(pReceiveMessageBody,12,3,5);//异味传感器空气显示
		_status.dustSensorAirQuality.value = mdSmart.message.getBits(pReceiveMessageBody,12,0,2);//灰尘传感器空气质量
		
		_status.pm2dot5Low.value = mdSmart.message.getBits(pReceiveMessageBody,13,0,7);//PM2.5浓度低字节
		_status.pm2dot5High.value = mdSmart.message.getBits(pReceiveMessageBody,14,0,7);//PM2.5浓度高字节
		_status.smellSensorAD.value = mdSmart.message.getBits(pReceiveMessageBody,15,0,7);//异味传感器的AD值
		
		_status.currentHumidity.value = mdSmart.message.getBits(pReceiveMessageBody,16,0,7);//当前湿度
		_status.indoorTemperature.value = mdSmart.message.getByte(pReceiveMessageBody,17);//室内温度(整数),表示方法：温度值 x 2 + 50
		
		_status.indoorTemperatureT1Decimal.value = mdSmart.message.getBits(pReceiveMessageBody,18,4,7);//室内温度T1温度的小数位
		_status.indoorHumidityDecimal.value = mdSmart.message.getBits(pReceiveMessageBody,18,0,4);//室内湿度的小数位
		
		_status.photosensitiveSensorCurrentLevel.value = mdSmart.message.getBits(pReceiveMessageBody,19,0,3);//光敏传感器当前亮度等级
		
		_status.waterIon.value = mdSmart.message.getBit(pReceiveMessageBody,19,6);//2015-03-11
		_status.beepFlag.value = mdSmart.message.getBit(pReceiveMessageBody,19,7);//2015-03-11

		_status.photosensitiveSensorAD.value = mdSmart.message.getBits(pReceiveMessageBody,20,0,7);//光敏传感器的AD值
		
		_status.faultCode.value = mdSmart.message.getByte(pReceiveMessageBody,21);//故障代码
		
		//frameCumulative = mdSmart.message.getByte(pReceiveMessageBody,22);//发送帧累加（1-254）
		
		_status.beepValue.value = mdSmart.message.getBits(pReceiveMessageBody,22,0,7);   // 2015-04-03
	}
	
	// 设备上报命令==>_status
	function _parseEquipmentReturnCommandBackToStatusA0(pReceiveMessageBody){
		_status.byte1Bit7.value = mdSmart.message.getBit(pReceiveMessageBody,1,7);//byte1Bit7(预留)
		_status.keyState.value = mdSmart.message.getBit(pReceiveMessageBody,1,6);//按键状态
		_status.fastCheckStatus.value = mdSmart.message.getBit(pReceiveMessageBody,1,5);//快检状态
		_status.timeingMode.value = mdSmart.message.getBit(pReceiveMessageBody,1,4);//定时方式
		_status.byte1Bit3.value = mdSmart.message.getBit(pReceiveMessageBody,1,3);//byte1Bit3(预留)
		_status.byte1Bit2.value = mdSmart.message.getBit(pReceiveMessageBody,1,2);//byte1Bit2(预留)
		_status.remoteControlCodeSource.value = mdSmart.message.getBit(pReceiveMessageBody,1,1);//遥控码来源
		_status.runningState.value = mdSmart.message.getBit(pReceiveMessageBody,1,0);//运行状态
		_status.settingMode1.value = mdSmart.message.getBits(pReceiveMessageBody,2,4,7);//净化器设定模式
		_status.settingMode2.value = mdSmart.message.getBits(pReceiveMessageBody,2,0,3);//除湿机模式
		//_status.settingTemperatureDot5.value = mdSmart.message.getBit(pReceiveMessageBody,2,4);//0.5
		//_status.settingTemperature.value = mdSmart.message.getBits(pReceiveMessageBody,2,0,3);//设定温度
		_status.mobileTerminalTimingInfoSwitch.value = mdSmart.message.getBit(pReceiveMessageBody,3,7);//移动终端定时信息
		_status.noPolarWindSpeedValue.value = mdSmart.message.getBits(pReceiveMessageBody,3,0,6);//无极风速值
		_status.timingOpen.value = mdSmart.message.getBit(pReceiveMessageBody,4,7);//定时开
		//_status.timingOpenAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,4,2,6);//定时开－绝对小时
		//_status.timingOpenAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,4,0,1) + (mdSmart.message.getBits(pReceiveMessageBody,6,4,7) << 2);//定时开－绝对分
		_status.timingOpenAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,4,0,6);//定时开－绝对小时
		_status.timingOpenAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,6,4,7);//定时开－绝对分
		
		_status.timingClose.value = mdSmart.message.getBit(pReceiveMessageBody,5,7);//定时关
		//_status.timingCloseAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,5,2,6);//定时关－绝对小时
		//_status.timingCloseAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,5,0,1) + (mdSmart.message.getBits(pReceiveMessageBody,6,0,3) << 2);//定时关－绝对分
		_status.timingCloseAbsoluteHours.value = mdSmart.message.getBits(pReceiveMessageBody,5,0,6);//定时关－绝对小时
		_status.timingCloseAbsoluteMinutes.value = mdSmart.message.getBits(pReceiveMessageBody,6,0,3);//定时关－绝对分

		_status.setHumidity.value = mdSmart.message.getBits(pReceiveMessageBody,7,0,7);//设定湿度
		_status.setHumidityPoint.value = mdSmart.message.getBits(pReceiveMessageBody,8,0,3);//设定湿度的小数点

		_status.childrenLock.value = mdSmart.message.getBit(pReceiveMessageBody,10,4);//童锁  2015-03-31
		_status.strainerAlarm.value = mdSmart.message.getBit(pReceiveMessageBody,9,7);//滤网提示
		
		_status.anion.value = mdSmart.message.getBit(pReceiveMessageBody,9,6);//负离子
		_status.comfortSleep.value = mdSmart.message.getBit(pReceiveMessageBody,9,5);//舒睡
		_status.waterPumpControlEffectiveNess.value = mdSmart.message.getBit(pReceiveMessageBody,9,4);//水泵控制是否有效
		_status.waterPumpControl.value = mdSmart.message.getBit(pReceiveMessageBody,9,3);//水泵控制
		_status.screenDisplay.value = mdSmart.message.getBits(pReceiveMessageBody,9,0,2);//屏显功能(预留)

		_status.waterIon.value = mdSmart.message.getBit(pReceiveMessageBody,10,5);//水离子	2015-03-31
		_status.defrosting.value = mdSmart.message.getBit(pReceiveMessageBody,10,7);//化霜
		_status.waterState.value = mdSmart.message.getBit(pReceiveMessageBody,10,6);//水箱状态
		//_status.humidifierModel.value = mdSmart.message.getBits(pReceiveMessageBody,8,4,6);//水箱状态	 2015-03-31

		_status.dustFullMarkAlarmTime2.value = mdSmart.message.getBits(pReceiveMessageBody,11,0,7) * 4 + 
		                                       mdSmart.message.getBits(pReceiveMessageBody,12,6,7);//尘满提示时间：单位小时 2015-03-11
	
		_status.byte12Bit6To7.value = mdSmart.message.getBits(pReceiveMessageBody,12,6,7);//byte12Bit6To7（预留）
		
		_status.smellSensorAirShow.value = mdSmart.message.getBits(pReceiveMessageBody,12,3,5);//异味传感器空气显示
		_status.dustSensorAirQuality.value = mdSmart.message.getBits(pReceiveMessageBody,12,0,2);//灰尘传感器空气质量
		
		_status.pm2dot5Low.value = mdSmart.message.getBits(pReceiveMessageBody,13,0,7);//PM2.5浓度低字节
		_status.pm2dot5High.value = mdSmart.message.getBits(pReceiveMessageBody,14,0,7);//PM2.5浓度高字节
		_status.smellSensorAD.value = mdSmart.message.getBits(pReceiveMessageBody,15,0,7);//异味传感器的AD值
		
		//_status.currentHumidity.value = mdSmart.message.getBits(pReceiveMessageBody,16,0,7);//当前湿度
		_status.currentHumidity.value = mdSmart.message.getByte(pReceiveMessageBody,16);//当前湿度
		_status.indoorTemperature.value = mdSmart.message.getByte(pReceiveMessageBody,17);//室内温度(整数),表示方法：温度值 x 2 + 50
		
		_status.indoorTemperatureT1Decimal.value = mdSmart.message.getBits(pReceiveMessageBody,18,4,7);//室内温度T1温度的小数位
		_status.indoorHumidityDecimal.value = mdSmart.message.getBits(pReceiveMessageBody,18,0,4);//室内湿度的小数位
		
		_status.photosensitiveSensorCurrentLevel.value = mdSmart.message.getBits(pReceiveMessageBody,19,0,3);//光敏传感器当前亮度等级
		
		_status.waterIon.value = mdSmart.message.getBit(pReceiveMessageBody,10,5);//2015-03-11
//		_status.beepFlag.value = mdSmart.message.getBit(pReceiveMessageBody,19,7);//2015-03-11
		_status.beepFlag.value = mdSmart.message.getBit(pReceiveMessageBody,10,3);//2015-05-07

		_status.photosensitiveSensorAD.value = mdSmart.message.getBits(pReceiveMessageBody,20,0,7);//光敏传感器的AD值
		
		_status.faultCode.value = mdSmart.message.getByte(pReceiveMessageBody,21);//故障代码
		
		//frameCumulative = mdSmart.message.getByte(pReceiveMessageBody,22);//发送帧累加（1-254）
	}
	
	function _doSynchronousEquipmentReturnCommandBackToCmd(pReceiveMessageBody){
		//按键状态
		mdSmart.message.setBit(_messageBodyControl,1,6,mdSmart.message.getBit(pReceiveMessageBody,1,6));
		//快检状态
		mdSmart.message.setBit(_messageBodyControl,1,5,mdSmart.message.getBit(pReceiveMessageBody,1,5));
		//定时方式
		mdSmart.message.setBit(_messageBodyControl,1,4,mdSmart.message.getBit(pReceiveMessageBody,1,4));
		//遥控码来源
		mdSmart.message.setBit(_messageBodyControl,1,1,0x01);
		//运行状态
		mdSmart.message.setBit(_messageBodyControl,1,0,mdSmart.message.getBit(pReceiveMessageBody,1,0));
		//净化器设定模式
		mdSmart.message.setBits(_messageBodyControl,2,4,7,mdSmart.message.getBits(pReceiveMessageBody,2,4,7));
		//除湿机模式
		mdSmart.message.setBits(_messageBodyControl,2,0,3,mdSmart.message.getBits(pReceiveMessageBody,2,0,3));
		
		//移动终端定时信息
		mdSmart.message.setBit(_messageBodyControl,3,7,0x00);
		//无极风速值
		mdSmart.message.setBits(_messageBodyControl,3,0,6,mdSmart.message.getBits(pReceiveMessageBody,3,0,6));
		//定时开
		mdSmart.message.setByte(_messageBodyControl,4,mdSmart.message.getByte(pReceiveMessageBody,4));
		//定时关
		mdSmart.message.setByte(_messageBodyControl,5,mdSmart.message.getByte(pReceiveMessageBody,5));
		//定时关&定时开
		mdSmart.message.setByte(_messageBodyControl,6,mdSmart.message.getByte(pReceiveMessageBody,6));
		
		//设定湿度
		mdSmart.message.setBits(_messageBodyControl,7,0,6,mdSmart.message.getBits(pReceiveMessageBody,7,0,6));
		//湿度的小数点
		mdSmart.message.setBits(_messageBodyControl,8,0,3,mdSmart.message.getBits(pReceiveMessageBody,8,0,3));
		//滤网提示
		mdSmart.message.setBit(_messageBodyControl,9,7,mdSmart.message.getBit(pReceiveMessageBody,9,7));
		//负离子
		mdSmart.message.setBit(_messageBodyControl,9,6,mdSmart.message.getBit(pReceiveMessageBody,9,6));
		//舒睡
		mdSmart.message.setBit(_messageBodyControl,9,5,mdSmart.message.getBit(pReceiveMessageBody,9,5));
		//水泵控制是否有效
		mdSmart.message.setBit(_messageBodyControl,9,4,0x00);
		//水泵控制
		mdSmart.message.setBit(_messageBodyControl,9,3,mdSmart.message.getBit(pReceiveMessageBody,9,3));
		//屏显功能
		mdSmart.message.setBits(_messageBodyControl,9,0,2,mdSmart.message.getBits(pReceiveMessageBody,9,0,2));
		
		//加湿器模式		2015-03-11
		//mdSmart.message.setBits(_messageBodyControl,10,0,2,mdSmart.message.getBits(pReceiveMessageBody,10,0,2));
		mdSmart.message.setBits(_messageBodyControl,10,0,2,mdSmart.message.getBits(pReceiveMessageBody,8,4,6));
		
		//水离子控制
		mdSmart.message.setBit(_messageBodyControl,10,5,mdSmart.message.getBit(pReceiveMessageBody,19,6));//2015-03-11
		//喇叭控制
		mdSmart.message.setBit(_messageBodyControl,10,6,mdSmart.message.getBit(pReceiveMessageBody,19,7));//2015-03-11		
		
		//尘满提示时间
		mdSmart.message.setByte(_messageBodyControl,11,mdSmart.message.getByte(pReceiveMessageBody,11));
		
		//童锁开关
		mdSmart.message.setBit(_messageBodyControl,8,7,mdSmart.message.getBit(pReceiveMessageBody,8,7));		
		
		//音量控制
		//mdSmart.message.setByte(_messageBodyControl,12,255);//2015-03-11
		
		if(mdSmart.message.getByte(pReceiveMessageBody,22) == 0){
			mdSmart.message.setByte(_messageBodyControl,12,7);
		}else{			
			mdSmart.message.setByte(_messageBodyControl,12,mdSmart.message.getByte(pReceiveMessageBody,22));//2015-04-03
		}
		
		//加湿器模式
//		mdSmart.message.setBits(_messageBodyControl,12,6,7,mdSmart.message.getBits(pReceiveMessageBody,12,6,7));
	}
	// 处理设备上报信息  2015-03-20
	function _doSynchronousEquipmentReturnCommandBackToCmdA0(pReceiveMessageBody){
		//按键状态
		mdSmart.message.setBit(_messageBodyControl,1,6,mdSmart.message.getBit(pReceiveMessageBody,1,6));
		//快检状态
		mdSmart.message.setBit(_messageBodyControl,1,5,mdSmart.message.getBit(pReceiveMessageBody,1,5));
		//定时方式
		mdSmart.message.setBit(_messageBodyControl,1,4,mdSmart.message.getBit(pReceiveMessageBody,1,4));
		//遥控码来源
		mdSmart.message.setBit(_messageBodyControl,1,1,0x01);
		//运行状态
		mdSmart.message.setBit(_messageBodyControl,1,0,mdSmart.message.getBit(pReceiveMessageBody,1,0));
		//净化器设定模式
		mdSmart.message.setBits(_messageBodyControl,2,4,7,mdSmart.message.getBits(pReceiveMessageBody,2,4,7));
		//除湿机模式
		mdSmart.message.setBits(_messageBodyControl,2,0,3,mdSmart.message.getBits(pReceiveMessageBody,2,0,3));
		
		//移动终端定时信息
		mdSmart.message.setBit(_messageBodyControl,3,7,0x00);
		//无极风速值
		mdSmart.message.setBits(_messageBodyControl,3,0,6,mdSmart.message.getBits(pReceiveMessageBody,3,0,6));
		//定时开
		mdSmart.message.setByte(_messageBodyControl,4,mdSmart.message.getByte(pReceiveMessageBody,4));
		//定时关
		mdSmart.message.setByte(_messageBodyControl,5,mdSmart.message.getByte(pReceiveMessageBody,5));
		//定时关&定时开
		mdSmart.message.setByte(_messageBodyControl,6,mdSmart.message.getByte(pReceiveMessageBody,6));
		
		//设定湿度
		mdSmart.message.setBits(_messageBodyControl,7,0,6,mdSmart.message.getBits(pReceiveMessageBody,7,0,6));
		//湿度的小数点
		mdSmart.message.setBits(_messageBodyControl,8,0,3,mdSmart.message.getBits(pReceiveMessageBody,8,0,3));
		//滤网提示
		mdSmart.message.setBit(_messageBodyControl,9,7,mdSmart.message.getBit(pReceiveMessageBody,9,7));
		//负离子
		mdSmart.message.setBit(_messageBodyControl,9,6,mdSmart.message.getBit(pReceiveMessageBody,9,6));
		//舒睡
		mdSmart.message.setBit(_messageBodyControl,9,5,mdSmart.message.getBit(pReceiveMessageBody,9,5));
		//水泵控制是否有效
		mdSmart.message.setBit(_messageBodyControl,9,4,0x00);
		//水泵控制
		mdSmart.message.setBit(_messageBodyControl,9,3,mdSmart.message.getBit(pReceiveMessageBody,9,3));
		//屏显功能
		mdSmart.message.setBits(_messageBodyControl,9,0,2,mdSmart.message.getBits(pReceiveMessageBody,9,0,2));
		
		//加湿器模式		2015-03-11
		//mdSmart.message.setBits(_messageBodyControl,10,0,2,mdSmart.message.getBits(pReceiveMessageBody,10,0,2));
		mdSmart.message.setBits(_messageBodyControl,10,0,2,mdSmart.message.getBits(pReceiveMessageBody,10,0,2));
		
		//水离子控制
		mdSmart.message.setBit(_messageBodyControl,10,5,mdSmart.message.getBit(pReceiveMessageBody,10,5));//2015-03-11
		//喇叭控制
		mdSmart.message.setBit(_messageBodyControl,10,6,mdSmart.message.getBit(pReceiveMessageBody,10,3));//2015-05-07		

		//水箱状态
		//if(mdSmart.message.getBit(pReceiveMessageBody,10,6) == 1){
		//	mdSmart.message.setBit(_messageBodyControl,10,6,mdSmart.message.getBit(pReceiveMessageBody,10,6));	
		//}else{
		//	mdSmart.message.setBit(_messageBodyControl,10,6,mdSmart.message.getBit(pReceiveMessageBody,10,6));	
		//}
		
		//水离子开关
		mdSmart.message.setBit(_messageBodyControl,10,5,mdSmart.message.getBit(pReceiveMessageBody,10,5));
		
		//童锁开关
		mdSmart.message.setBit(_messageBodyControl,8,7,mdSmart.message.getBit(pReceiveMessageBody,10,4));			
		
		//尘满提示时间
		mdSmart.message.setByte(_messageBodyControl,11,mdSmart.message.getByte(pReceiveMessageBody,11));
		
		//
		
		//音量控制
//		mdSmart.message.setByte(_messageBodyControl,12,7);//2015-03-11
		
	}
    function _CRC8(pBytes) {
        return mdSmart.message.CRC8(pBytes);
    }
	return{
		/**
		 * 生成设备当前状态查询命令
		 *
		 *@return {byteArray} 设备当前状态查询命令
		 */
		cmdRequestApplianceStatus:function(){
			var messageBody = _messageBodyRequestStatus;
			//当前状态查询引导码
			mdSmart.message.setByte(messageBody,0,0x41);
			//收到回传数据标志
			mdSmart.message.setBit(messageBody,1,7,0x00);
			//按键状态
			mdSmart.message.setBit(messageBody,1,6,0x00);
			//独立码类型
			mdSmart.message.setBits(messageBody,1,0,5,0x00);
			//Byte2 TODO
			mdSmart.message.setByte(messageBody,2,0x00);
			//Byte3
			mdSmart.message.setByte(messageBody,3,0xFF);
			//Byte4
			mdSmart.message.setByte(messageBody,4,0x03);
			//Byte7
			mdSmart.message.setByte(messageBody,7,0x02);
			//发送帧累加
			frameCumulative=frameCumulative+1;
			
			if(frameCumulative>0&&frameCumulative<255)
			{
				mdSmart.message.setByte(messageBody,20,frameCumulative);
			}
			else if(frameCumulative==0||frameCumulative==255)
			{
				frameCumulative=1;
				mdSmart.message.setByte(messageBody,20,frameCumulative);
			}
			//CRC8
			mdSmart.message.setByte(messageBody,21,_CRC8(messageBody));
			var message = mdSmart.message.createMessage(0xFC,0x03,messageBody);
			return message;
		},		
	
		/**	/**
		 * SET-Byte4
		 *@param {Number} p1 指示
		 *				   0x03 - BYTE NO.7 为有效指令（查询状态）
		 *				   其他 - 无效指令
		 */
		setSetByte4:function(p1){
			mdSmart.message.setByte(_messageBodyRequestStatus,4,p1);
		},
		/**
		 * SET-查询状态
		 *@param {Number} p1 指示
		 *				   0x02 - ???
		 */
		setSetByte7:function(p1){
			mdSmart.message.setByte(_messageBodyRequestStatus,7,p1);
		},
		/**
		 * 生成设备控制命令
		 *
		 *@return {byteArray} 设备控制命令
		 */
		cmdControl:function(){
			var messageBody = _messageBodyControl;
			//设备控制命令引导码
			mdSmart.message.setByte(messageBody,0,0x48);
			//按键状态
			mdSmart.message.setBit(messageBody,1,6,0x01);
			//遥控码来源
			mdSmart.message.setBit(messageBody,1,1,0x01);
			
			//屏显功能
			//mdSmart.message.setBits(messageBody,9,0,2,0x00);
			
			//发送帧累加
			frameCumulative=frameCumulative+1;
			if(frameCumulative>0&&frameCumulative<255)
			{
				mdSmart.message.setByte(messageBody,21,frameCumulative);
			}
			else if(frameCumulative==0||frameCumulative==255)
			{
				frameCumulative=1;
				mdSmart.message.setByte(messageBody,21,frameCumulative);
			}
			
		bridge.logToIOS("FC_P03 cmdControl frameCumulative= "+ frameCumulative);
			//CRC8
			mdSmart.message.setByte(messageBody,22,_CRC8(messageBody));
			var message = mdSmart.message.createMessage(0xFC,0x02,messageBody);
			return message;
		},		
		/**
		 * SET-运行状态
		 *@param {Number} p1 运行状态
		 *                 0-关机
		 *                 1-开机
		 */
		setRunningState:function(p1){
			mdSmart.message.setBit(_messageBodyControl,1,0,p1);
		},
		/**
		 * 生成电源控制命令
		 *
		 * 命令类型:控制
		 * 功能号:电源控制
		 * 
		 *@param {Number} p1 运行状态
		 *                 0-关机
		 *				   1-开机
		 *@return {byteArray} 电源控制命令
		 */
		cmdCtrolPower:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			// 设置关机的时候  负离子设为0
			if (p1 == 0x00) {
				this.setAnion(0x00);
				this.setWaterion(0x00);
				this.setWorkMode3(0x00);
			} else {
				//屏显功能
				//mdSmart.message.setBits(cmdBytes,9,0,2,0x00);	
				mdSmart.message.setBits(_messageBodyControl,9,0,2,0x00);
			}
			this.setRunningState(p1);
			return this.cmdControl();
		},
		/**
		 * SET-灯光
		 *@param {Number} p1 状态
		 *                 7-关闭
		 *                 0-开启
		 */
		setScreenDisplay:function(p1){
			mdSmart.message.setBits(_messageBodyControl,9,0,2,p1);
		},	
		cmdCtrolScreenDisplay:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setScreenDisplay(p1);
			return this.cmdControl();
		},
		
		/**
		 * SET-水离子  2015-03-11
		 *@param {Number} p1 运行状态
		 *                 0-关
		 *                 1-开
		 */
		setWaterion:function(p1){	
			mdSmart.message.setBit(_messageBodyControl,10,5,p1);
		},		
		cmdCtrolWaterion:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setWaterion(p1);
			return this.cmdControl();
		},
	
		/**
		 * SET-喇叭   2015-03-11
		 *@param {Number} p1 运行状态
		 *                 0-关
		 *                 1-开
		 */
		setChildrenLock:function(p1){	
			mdSmart.message.setBit(_messageBodyControl,8,7,p1);
		},	
		cmdCtrolChildrenLock:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setChildrenLock(p1);
			return this.cmdControl();
		},
	
		/**
		 * SET-喇叭   2015-03-11
		 *@param {Number} p1 运行状态
		 *                 0-关
		 *                 1-开
		 */
		setBeepflag:function(p1){	
			mdSmart.message.setBit(_messageBodyControl,10,6,p1);
		},	
		cmdCtrolBeepflag:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setBeepflag(p1);
			return this.cmdControl();
		},
		cmdCtrolHumidity:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setWorkMode3(p1);
			return this.cmdControl();
		},
		/**
		 * SET-音量   2015-03-11
		 *@param {Number} p1 音量值
		 *                 0-关
		 *                 1-255 音量值
		 */
		setBeepvalue:function(p1){	
			mdSmart.message.setBits(_messageBodyControl,12,0,7,p1);
		},			
		/**
		 * SET-负离子
		 *@param {Number} p1 运行状态
		 *                 0-关
		 *                 1-开
		 */
		setAnion:function(p1){	
			mdSmart.message.setBit(_messageBodyControl,9,6,p1);
		},
		/**
		 * 生成负离子机控制命令
		 *
		 * 命令类型:控制
		 * 功能号:负离子机控制
		 * 
		 *@param {Number} p1 运行状态
		 *                 0-关
		 *				   1-开
		 *@return {byteArray} 负离子机控制命令
		 */
		cmdCtrolAnion:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setAnion(p1);
			return this.cmdControl();
		},
		/**
		 * SET-定时开
		 *@param {Number} p1 定时开
		 *				 	0- 关
		 *				 	1- 开
		 *				  p2 小时
		 *				  p3 分
		 */
		setTimingOpen:function(p1,p2,p3){
			mdSmart.message.setBit(_messageBodyControl,4,7,p1);
			if(p2 != undefined){
				//mdSmart.message.setBits(_messageBodyControl,4,2,6,p2);
				mdSmart.message.setBits(_messageBodyControl,4,0,6,p2);
			}
			if(p3 != undefined){
				//mdSmart.message.setBits(_messageBodyControl,4,0,1,mdSmart.message._getBits(p3,0,1));
				//mdSmart.message.setBits(_messageBodyControl,6,4,7,mdSmart.message._getBits(p3,2,5));
				mdSmart.message.setBits(_messageBodyControl,6,4,7,p3);
			}
		},
		/**
		 * SET-定时关
		 *@param {Number} p1 定时关
		 *				 	0- 关
		 *				 	1- 开
		 *				  p2 小时
		 *				  p3 分
		 */
		setTimingClose:function(p1,p2,p3){
			mdSmart.message.setBit(_messageBodyControl,5,7,p1);
			if(p2 != undefined){
				//mdSmart.message.setBits(_messageBodyControl,5,2,6,p2);
				mdSmart.message.setBits(_messageBodyControl,5,0,6,p2);
			}
			if(p3 != undefined){
				//mdSmart.message.setBits(_messageBodyControl,5,0,1,mdSmart.message._getBits(p3,0,1));
				//mdSmart.message.setBits(_messageBodyControl,6,0,3,mdSmart.message._getBits(p3,2,5));
				mdSmart.message.setBits(_messageBodyControl,6,0,3,p3);
			}
		},
		/**
		 * SET-移动终端定时信息
		 *@param {Number} p1 状态
		 *                 0-无效
		 *                 1-有效
		 */
		setMobileTerminalTimingInfoSwitch:function(p1){
			mdSmart.message.setBit(_messageBodyControl,3,7,p1);
		},
		/**
		 * 生成定时关机命令
		 *
		 * 命令类型:设置
		 * 功能号:定时设置
		 * 
		 *@param {Number} p1 功能选择
		 *                 0-关
		 *				   1-开
		 *		 {Number} p2 小时
		 *		 {Number} p3 分钟
		 *@return {byteArray} 定时关机命令
		 */
		cmdSetTimerClose:function(p1,p2,p3){
			this.setMobileTerminalTimingInfoSwitch(0x01);
			this.setWaterPumpControlEffectiveNess(0x00);
			// 设置关机的时候  负离子设为0
			//this.setAnion(0x00);

			this.setTimingClose(p1,p2,p3);
			return this.cmdControl();
		},
		/**
		 * 生成定时设置命令
		 *
		 * 命令类型:设置
		 * 功能号:定时设置
		 * 
		 *@param {Number} p1 功能选择
		 *                 0-定时关机
		 *				   1-定时开机
		 *		 {Number} p2 小时
		 *		 {Number} p3 分钟
		 *@return {byteArray} 定时设置命令
		 */
		cmdSetTimer:function(p1,p2,p3){
			this.setMobileTerminalTimingInfoSwitch(0x01);
			this.setWaterPumpControlEffectiveNess(0x00);
			if(p1 == 0x00){
				
				// 定时关机负离子设为0
				//this.setAnion(0x00);
				
				if(p2 == 0x00 && p3 == 0x00){
					this.setTimingClose(0x00);
				}else{
					this.setTimingClose(0x01,p2,p3);
				}
			}
			if(p1 == 0x01){
				if(p2 == 0x00 && p3 == 0x00){
					this.setTimingOpen(0x00);
				}else{
					this.setTimingOpen(0x01,p2,p3);
				}
			}
			return this.cmdControl();
		},
		/**
		 * SET-工作模式
		 *@param {Number} p1 工作模式
		 *                 0-无效
		 *                 1-自动
		 *				   2-手动
		 */
		setWorkMode:function(p1){
			mdSmart.message.setBits(_messageBodyControl,2,4,7,p1);
			if(p1 == 0x01){
				this.setWorkMode3(1);
			}
		},
		
		/**
		 * SET-除湿机模式
		 *@param {Number} p1 工作模式
		 *                 0-无效
		 *                 1—设定除湿
		 *                 2—连续除湿
		 *                 3—自动除湿
		 *                 4—干衣除湿
		 */
		setWorkMode2:function(p1){
			mdSmart.message.setBits(_messageBodyControl,2,0,3,p1);
		},
		
		/**
		 * SET-加湿器模式
		 *@param {Number} p1 工作模式
		 *                 0-无效
		 *                 1—设定除湿
		 *                 2—连续除湿
		 *                 3—自动除湿
		 *                 4—干衣除湿
		 */
		setWorkMode3:function(p1){
			mdSmart.message.setBits(_messageBodyControl,10,0,2,p1);
		},
		
		/**
		 * SET-舒睡
		 *@param {Number} p1 舒睡
		 *				 	0- 关
		 *				 	1- 开
		 */
		setComfortSleep:function(p1){
			mdSmart.message.setBit(_messageBodyControl,9,5,p1);
		},
		/**
		 * SET-水泵控制是否有效
		 *@param {Number} p1 是否有效
		 *				 	0- 关
		 *				 	1- 开
		 */
		setWaterPumpControlEffectiveNess:function(p1){
			mdSmart.message.setBit(_messageBodyControl,9,4,p1);
		},
		/**
		 * 生成工作模式设置命令
		 *
		 * 命令类型:设置
		 * 功能号:工作模式设置
		 * 
		 *@param {Number} p1 功能细化1
		 *                 0-无效
		 *                 1-自动
		 *				   2-手动
		 *@return {byteArray} 工作模式设置命令
		 */
		cmdSetWorkMode:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setWorkMode(p1);// TODO
			return this.cmdControl();
		},
		/**
		 * 生成舒睡模式设置命令
		 *
		 * 命令类型:设置
		 * 功能号:舒睡模式设置
		 * 
		 *@param {Number} p1 开关
		 *				 	0- 关
		 *				 	1- 开
		 *@return {byteArray} 生成舒睡模式设置命令
		 */
		cmdSetSleepMode:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			this.setComfortSleep(p1);
			return this.cmdControl();
		},
		/**
		 * SET-风速
		 *@param {Number} p1 风速
		 *                 20-静音风
		 *				   40-低风
		 *				   60-中风
		 *				   80-高风
		 *				  101-固定风
		 *				  102-自动风
		 *				  1～100，大于100为自动风
		 */
		setNoPolarWindSpeedValue:function(p1){
			mdSmart.message.setBits(_messageBodyControl,3,0,6,p1);
		},
		/**
		 * 生成风速档位设置命令
		 *
		 * 命令类型:设置
		 * 功能号:风速档位设置
		 * 
		 *@param {Number} p1 功能细化1
		 *                 20-静音风
		 *				   40-低风
		 *				   60-中风
		 *				   80-高风
		 *				  101-固定风
		 *				  102-自动风
		 *@return {byteArray} 风速档位设置命令
		 */
		cmdSetWindSpeedLevel:function(p1){
			this.setMobileTerminalTimingInfoSwitch(0x00);
			this.setWaterPumpControlEffectiveNess(0x00);
			// 调节风速时，模式自动切换为手动模式
			this.setWorkMode(0x02);
			this.setNoPolarWindSpeedValue(p1);
			return this.cmdControl();
		},
		/**
		 * 设定帧累加
		 */
		setFrameCumulative:function(p1){
			frameCumulative=p1;
		},
		/**
		 * 获取帧累加
		 */
		getFrameCumulative:function(p1){
			return frameCumulative;
		},
		/**
		 * 解析报文
		 *@param {byteArray} message 报文
		 *@return {json}
		 */
		parseMessageForView:function(message){
			return _parseMessage(message);
		},
		/**
		 * 设备返回命令
		 */
		getStatusMessage:function(){
			return _equipmentReturnCommandBack;
		},
		/**
		 * 生成设备当前机型查询命令   2015-03-04
		 *
		 *@return {byteArray} 设备当前机型查询命令
		 */
		cmdCheckType:function(){
			var messageBody = _messageBodyCheckType;
			//当前状态查询引导码
			mdSmart.message.setByte(messageBody,0,0x00);
			var message = mdSmart.message.createMessage(devType,0xA0,messageBody);
			//alert(message);
			return message;
		},
		
		//2015-04-09
       cmdNewVerForCheck:function(p1,p2){
	    var messageBody =[];
			//当前状态查询引导码
		   mdSmart.message.setByte(messageBody,0,0xB1);
           mdSmart.message.setByte(messageBody,1,p1);
         
           var si; 
           var sk = 2;
           for(si = 0; si < p1; si++){
            mdSmart.message.setByte(messageBody,sk,p2[2*si + 1]);
            sk = sk + 1;
            mdSmart.message.setByte(messageBody,sk,p2[2*si]);
            sk = sk + 1;
           }
            mdSmart.message.setByte(messageBody,sk,0x00);
            
			mdSmart.message.setByte(messageBody,(2 + 2 * p1),_CRC8(messageBody));
			
			
			var message = mdSmart.message.createMessage(devType,0x03,messageBody);
			
	       return message;       	
       },
		/**
		 * 生成新协议控制命令   2015-04-08
		 *p1:命令标识：02－控制命令，03-查询命令
		 *p2:属性代码：2个字节，低位在前
		 *p3:属性长度
		 *p4:属性值
		 *@return {byteArray} 新协议控制命令
		 */
		cmdNewVer:function(p1,p2,p3){
			var messageBody =[];
			//当前状态查询引导码
		   mdSmart.message.setByte(messageBody,0,0xB0);
           mdSmart.message.setByte(messageBody,1,0x01);
            
            mdSmart.message.setByte(messageBody,2,p1[0]);
            mdSmart.message.setByte(messageBody,3,p1[1]);
            
            mdSmart.message.setByte(messageBody,4,p2);  //长度
            
            var si;
            for(si = 0; si < p2; si++){
            	  mdSmart.message.setByte(messageBody,5 + si,p3[si]);
            }
            
            mdSmart.message.setByte(messageBody,5 + p2,0x00);
            
			mdSmart.message.setByte(messageBody,5 + p2,_CRC8(messageBody));
			//alert(messageBody);
			
			var message = mdSmart.message.createMessage(devType,0x02,messageBody);
			
			return message;
		},	
		
		/** 2015-04-17
		 * SET-设置音量大小
		 *@param {Number} p1 ,0:关闭；1-255范围
		 *                
		 *               
		 */
		setDevSoundPower:function(p1){
			mdSmart.message.setByte(_messageBodyControl,12,p1);
			return this.cmdControl();
		},
		
		/**
		 * 解析A0命令返回值   2015-03-04
		 *
		 *@return 设备对应机型
		 */
		parseA0MessageForView:function(messageA0){
			return _parseTypeMessage(messageA0);
		}
	}
}