mdSmart.FCController = function() {

	var _dataParse = new mdSmart.msg0xFC();
	var tmpApplianceId = bridge.getCurrentApplianceID();
	var deviceType = localStorage.getItem(tmpApplianceId + "deviceType");
	var modeCount = 2;
	var filterCheckState = 0;
	var filterQueryResultState = 0;
	var timehandle = 0;
	var mideaAfterSaleUrl = "";
	var mideaStoreUrl = "";
	var mideaFanUrl = "";
	var setTimeIsAlreadyShow = false; //用于区别从卡片界面点击定时进来，是否显示过

	var appPages = ['home', 'setting', 'health-check', 'sound-control', 'more-function'];

	(function init() {
		requestExternalUrl();
		getDeviceType();
		$(document).bind('recieveMessage', {}, function(event, message) {
			updateShow("", message);
		});

	}());

	//获取家电机型
	function getDeviceType() {
	   bridge.logToIOS("getdevicetype controlpanel get " + tmpApplianceId + "deviceType="+ deviceType);
		if (("" == deviceType) || (undefined == deviceType) || (null == deviceType)) {
			var cmdBytes = _dataParse.cmdCheckType();
			var cmdId = bridge.startCmdProcess(cmdBytes, function(data) {
				deviceType = _dataParse.parseA0MessageForView(data);
				localStorage.setItem(tmpApplianceId + "deviceType", deviceType);
				functionDistinguish();
			},function(errCode){
				if (errCode == "-1") {
					functionDistinguish();
				}
			});
		} else {
			functionDistinguish();
		}
	}

	//查询设备状态
	this.cmdRequestApplianceStatus = function() {
		getDeviceType();
		var cmdBytes = _dataParse.cmdRequestApplianceStatus();
		var cmdId = bridge.startCmdProcess(cmdBytes, function(data) {
			updateShow(cmdBytes, data);
		});
		if (needShowSetTimer()) {
			$("#timerDiv").show();
		}
	}

	//按钮绑定控制命令
	this.sendControlMsg = function(controlType) {
		var cmdBytes = "";
		var parameter = "";
		//关机状态不可用
		if (s.runStatus == 0) {
			switch (controlType) {
				case "MODE":
				case "WINDSPEED":
				case "NEGATIVE":
				case "WATERION":
				case "ATMOSPHERE":
				case "HUMIDI":
				case "CHILDRENLOCK":
				case "VOICESWITCH":
				case "SETTIMER":
				case "IFOPENWINDSPEEDDIV":
				case "IFOPENTIMER":
					showMessage("关机状态下不可用");
					break;
				case "POWER": //开关
					//cmdBytes = _dataParse.cmdCtrolPower(0x01);
					s.runStatus = 1; //开关机
					init();
					break;
				default:
					break;
			}
		} else {

			switch (controlType) {
				case "POWER": //开关
					//if (s.runStatus == 1) {
					//	parameter = 0;
					//	//TODO
					//} else if (s.runStatus == 0) {
					//	parameter = 1;
					//}
					//cmdBytes = _dataParse.cmdCtrolPower(parameter);
					s.runStatus = !s.runStatus; //开关机
					break;
				case "MODE": //模式
					$('#modeDiv').show();
					break;
				case "IFOPENWINDSPEEDDIV": //风速
					$("#windSlider .ui-slider-range").width(s.windSpeed + "%");
					$("#windSlider .ui-slider-handle").css('left', s.windSpeed + "%");
					$("#windValue").text(s.windSpeed);
					$('#windSpeedDiv').show();
					break;
				case "WINDSPEED": //风速
					parameter = $("#windValue").text();
					//cmdBytes = _dataParse.cmdSetWindSpeedLevel(parameter);
					s.windSpeed = $("#windValue").text();
					$("#windSpeed").text('风速 ' + s.windSpeed + '%');
					break;
				case "NEGATIVE": //负离子
					//if (s.ionSetSwitch == 1) {
					//	parameter = 0;
					//} else if (s.ionSetSwitch == 0) {
					//	parameter = 1;
					//}
					//cmdBytes = _dataParse.cmdCtrolAnion(parameter);
					s.ionSetSwitch = !s.ionSetSwitch;
					break;
				case "WATERION": //水离子
					//if (s.waterIcon == 1) {
					//	parameter = 0;
					//} else if (s.waterIcon == 0) {
					//	parameter = 1;
					//}
					//cmdBytes = _dataParse.cmdCtrolWaterion(parameter);
					s.waterIcon = !s.waterIcon;
					break;
				case "ATMOSPHERE": //灯光
					//if (s.atmosphere == 7) {
					//	parameter = 0;
					//	s.atmosphere = 0;
					//} else {
					//	parameter = 7;
					//	s.atmosphere = 7;
					//}
					s.atmosphere = s.atmosphere? 0: 7;
					//cmdBytes = _dataParse.cmdCtrolScreenDisplay(parameter);
					break;
				case "HUMIDI": //加湿
					//if (s.mode_FD_return == 1) {
					//	parameter = 0;
					//} else {
					//	parameter = 1;
					//}
					s.mode_FD_return = !s.mode_FD_return;
					//cmdBytes = _dataParse.cmdCtrolHumidity(parameter);
					break;
				case "CHILDRENLOCK": //童锁
					if (s.childLock == 1) {
						parameter = 0;
					} else if (s.childLock == 0) {
						parameter = 1;
					}
					cmdBytes = _dataParse.cmdCtrolChildrenLock(parameter);
					break;
				case "VOICESWITCH": //语音
					if (s.voiceswitch == 1) {
						parameter = 0;
					} else if (s.voiceswitch == 0) {
						parameter = 1;
					}
					cmdBytes = _dataParse.cmdCtrolBeepflag(parameter);
					break;
				case "IFOPENTIMER":
					getSetTimeSec();
					$('#timerDiv').show();
					break;
				case "SETTIMER": //定时
					var sec = $("#sel").val() || 1800;
					var hour = Math.floor(sec / 900);
					var minute = Math.floor(15 - parseInt((sec % 900) / 60));
					//var switchState = sec == 0 ? 0 : 1;
					//if (sec == 0) {
					//	cmdBytes = _dataParse.cmdSetTimerClose(0x00);
					//} else {
					//	cmdBytes = _dataParse.cmdSetTimerClose(0x01, hour, minute);
					//}
					s.timingOffSwitch = sec == "0" ? 0 : 1;
					break;
				default:
					break;
			}
		}
		//if (cmdBytes != "") {
		//	var cmdId = bridge.startCmdProcess(cmdBytes, function(data) {
		//		updateShow(cmdBytes, data);
		//	});
		//}

		switch (controlType) {
			case "POWER":
			case "NEGATIVE":
			case "WATERION":
			case "ATMOSPHERE":
			case "HUMIDI":
			case "IFOPENTIMER":
			case "SETTIMER":
			case "CHILDRENLOCK":
				init();
				break;
		}

	}

	//改变语音播报类型  0:女声		1:男声
	this.openBoySound = function() {
		if (s.voiceType == 0) {
			changeVoiceType(1);
		}
	}
	this.openGirlSound = function() {
		if (s.voiceType == 1) {
			changeVoiceType(0);
		}
	}
	
	this.controlMode = function(modeValue) {
		//var cmdBytes = _dataParse.cmdSetWorkMode(modeValue);
		//var cmdId = bridge.startCmdProcess(cmdBytes, function(data) {
		//	updateShow(cmdBytes, data);
		//});
		initMode(modeValue);
	}

	//是否需要弹出定时控件
	function needShowSetTimer() {
		var needShow = false;
		var parameters = bridge.getPageParameters();
		if (parameters != null && parameters != '-1' && parameters != -1) {
			// popFlg 定时关 0:关 1:开
			if ('0' == parameters.popFlg && !setTimeIsAlreadyShow) {
				needShow = true;
				setTimeIsAlreadyShow = true;
			}
		}
		return needShow;
	}

	//改变语音播报类型
	function changeVoiceType(p1) {
		//按钮处理方法
		var cmdValue = []; //属性命令
		cmdValue[0] = 0x0a; //低位
		cmdValue[1] = 0x02; //高位
		var msgValueLength = 1; //属性长度
		var msgValue = []; //属性值
		msgValue[0] = p1; //属性值 

		var cmdBytes = _dataParse.cmdNewVer(cmdValue, msgValueLength, msgValue);
		var cmdId = bridge.startCmdProcess(cmdBytes, function(data) {
			receiveNewProtocol(data);
		});
	}

	//改变音量值大小
	this.changeVoiceValue = function() {
		var voiceValue = $("#amount").text();
		var cmdBytes = _dataParse.setDevSoundPower(voiceValue);

		var cmdId = bridge.startCmdProcess(cmdBytes, function(data) {
			var jsonStatus = _dataParse.parseMessageForView(data).status;
			s.voiceValue = jsonStatus.beepValue.value; //音量大小
		});
	}

	//百宝箱功能区分
	function moreFunctionDistinguish() {
		if (ss.hasFilterCheck && !ss.hasVoiceSwitch) {			// 有滤网，无音量调节
			$("#filterCheck").css('display', 'block');
			$("#filterCheck").removeClass("borderBottom");
			$("#commonFunction").css('display', 'none');
		} else if(!ss.hasFilterCheck && ss.hasVoiceSwitch) {		// 无滤网，有音量调节
			$("#filterCheck").css('display', 'none');
			$("#commonFunction").css('display', 'block');
		} else if(ss.hasFilterCheck && ss.hasVoiceSwitch) {		// 有滤网，有音量调节
			$("#filterCheck").css('display', 'block');
			$("#commonFunction").css('display', 'block');
		} else {													// 无滤网，无音量调节
			$("#moreFunction").css('display', 'none');
			$("#whiteSub1").css('display', 'none');
		}
		
//		if (deviceType == "6") { //  NL  声音
//			$("#filterCheck").css('display', 'none');
//			$("#commonFunction").css('display', 'block');
//		} else if (deviceType == "7") { //  NI3
//			$("#filterCheck").css('display', 'block');
//			$("#filterCheck").removeClass("borderBottom");
//			$("#commonFunction").css('display', 'none');
//		} else {
//			$("#moreFunction").css('display', 'none');
//			$("#whiteSub1").css('display', 'none');
//		}
	}


	//功能机型区分
	function functionDistinguish() {
	   bridge.logToIOS("functionDistinguish controlpanel get " + tmpApplianceId + "deviceType="+ deviceType);
		if (deviceType == "1") { //  NM
			// 隐藏加湿、水离子、童锁、音量控制
			ss.hasHumidity = false;
			ss.hasWaterIcon = false;
			ss.hasChildLock = false;
			ss.hasVoiceSwitch = false;
			$("#infoFooterDiv2").css('display', 'none');
			$("#windSpeed").removeClass("windSpeedd").addClass("onlyWindSpeen");
			$("#smallFunction").removeClass("fcSmallFunction").addClass("fcSmallFunction2");
		} else if (deviceType == "2") { //  NM1
			// 隐藏加湿、灯光、水离子、音量控制
			ss.hasHumidity = false;
			ss.hasAtmosphere = false;
			ss.hasWaterIcon = false;
			ss.hasVoiceSwitch = false;
			$("#infoFooterDiv2").css('display', 'none');
			$("#smallFunction").removeClass("fcSmallFunction").addClass("fcSmallFunction2");
			$("#windSpeed").removeClass("windSpeedd").addClass("onlyWindSpeen");
		} else if (deviceType == "3") { //  NN
			// 隐藏加湿、水离子、音量控制、灯光
			ss.hasHumidity = false;
			ss.hasWaterIcon = false;
			ss.hasVoiceSwitch = false;
			ss.hasAtmosphere = false;
			$("#infoFooterDiv2").css('display', 'none');
			$("#windSpeed").removeClass("windSpeedd").addClass("onlyWindSpeen");
			$("#smallFunction").removeClass("fcSmallFunction").addClass("fcSmallFunction2");
		} else if (deviceType == "4") { //  NI
			// 隐藏加湿、灯光、水离子、童锁、音量控制
			ss.hasHumidity = false;
			ss.hasAtmosphere = false;
			ss.hasWaterIcon = false;
			ss.hasChildLock = false;
			ss.hasVoiceSwitch = false;
		} else if (deviceType == "5") { //  NY	无水离子
			// 隐藏水离子、音量控制、灯光
			ss.hasWaterIcon = false;
			ss.hasAtmosphere = false;
			ss.hasVoiceSwitch = false;
		} else if (deviceType == "6") { //  NL  无负离子
			// 隐藏负离子、加湿、睡眠
			ss.hasIonSetSwitch = false;
			ss.hasHumidity = false;
		} else if (deviceType == "7") { //  NI3  		
			// 隐藏加湿、灯光、水离子、童锁、音量控制、滤网脏堵
			ss.hasHumidity = false;
			ss.hasAtmosphere = false;
			ss.hasWaterIcon = false;
			ss.hasChildLock = false;
			ss.hasVoiceSwitch = false;
			ss.hasFilterCheck = true;
		} else if (deviceType == "10"){ // 	NL2		带滤网脏堵
			// 隐藏负离子、加湿、睡眠
			ss.hasIonSetSwitch = false;
			ss.hasHumidity = false;
			ss.hasFilterCheck = true;
		} else if (deviceType == "11"){ // 	NY2		带滤网脏堵
			// 隐藏水离子、音量控制、灯光
			ss.hasWaterIcon = false;
			ss.hasAtmosphere = false;
			ss.hasVoiceSwitch = false;
			ss.hasFilterCheck = true;
		} else {
			s.number = 10;
		}
		if (ss.hasHumidity) {
			$("#divHumidi").css('display', 'block');
		} else {
			$("#divHumidi").css('display', 'none');
		}

		if (ss.hasAtmosphere) {
			$("#divAtmosphere").css('display', 'block');
		} else {
			$("#divAtmosphere").css('display', 'none');
		}

		if (ss.hasWaterIcon) {
			$("#divWaterIon").css('display', 'block');
		} else {
			$("#divWaterIon").css('display', 'none');
		}

		if (ss.hasChildLock) {
			$("#divChildrenLock").css('display', 'block');
		} else {
			$("#divChildrenLock").css('display', 'none');
		}

		if (ss.hasVoiceSwitch) {
			$("#divVoiceSwitch").css('display', 'block');
		} else {
			$("#divVoiceSwitch").css('display', 'none');
		}
		if (ss.hasIonSetSwitch && deviceType != '5') {
			$("#divNegative").css('display', 'block');
		} else {
			$("#divNegative").css('display', 'none');
		}
		if (ss.hasIonSetSwitch && deviceType == '5') {
			$("#divNegative2").css('display', 'block');
		} else {
			$("#divNegative2").css('display', 'none');
		}
	};

	//更新本地数据及界面显示
	function updateShow(dataRequest, dataBack) {
		moreFunctionDistinguish();
		var jsonStatus = _dataParse.parseMessageForView(dataBack).status;
		s.runStatus = jsonStatus.runningState.value; //开关机
		s.pmLowValue = airQualityIsInvalid(jsonStatus.getAirQuality()); //PM2.5值
		s.humidity_cur = jsonStatus.currentHumidity.value < 100 ? jsonStatus.currentHumidity.value : 51;
		s.waterIcon = jsonStatus.waterIon.value; //水离子
		s.windSpeed = jsonStatus.noPolarWindSpeedValue.value; //风速
		s.mode_FD_return = jsonStatus.humidifierModel.value; //加湿
		s.mode_FC_return = jsonStatus.settingMode1.value; //模式
		s.ionSetSwitch = jsonStatus.anion.value; //负离子
		s.childLock = jsonStatus.childrenLock.value; //童锁
		s.atmosphere = jsonStatus.screenDisplay.value; //灯光
		s.voiceswitch = jsonStatus.beepFlag.value; //语音
		s.timingOffHour = jsonStatus.timingCloseAbsoluteHours.value; //定时关机小时
		s.timingOffMinute = jsonStatus.timingCloseAbsoluteMinutes.value; //定时关机分钟 
		s.timingOffSwitch = jsonStatus.timingClose.value;
		s.voiceValue = jsonStatus.beepValue.value < 1 ? 1 : jsonStatus.beepValue.value; //音量大小
		s.indoorTmp = jsonStatus.indoorTemperature.value >= 0 ? parseInt((parseInt(jsonStatus.indoorTemperature.value) - 50) / 2) : 25;
		s.waterState = jsonStatus.waterState.value;
		var dustSensorAirQuality = jsonStatus.dustSensorAirQuality.value; // 灰尘传感器空气质量
		var smellSensorAirShow = jsonStatus.smellSensorAirShow.value; // 异味传感器空气质量
		var airLevelName = "";
		var comprehensiveQuality = 0; // 综合质量等级初始化
		if (dustSensorAirQuality >= smellSensorAirShow) {
			comprehensiveQuality = dustSensorAirQuality;
		} else {
			comprehensiveQuality = smellSensorAirShow;
		}
		switch (comprehensiveQuality) {
			case 0:
				airLevelName = mdSmart.i18n.AIR_LEVEL_1;
				break;
			case 1:
				airLevelName = mdSmart.i18n.AIR_LEVEL_1;
				break;
			case 2:
				airLevelName = mdSmart.i18n.AIR_LEVEL_2;
				break;
			case 3:
				airLevelName = mdSmart.i18n.AIR_LEVEL_2;
				break;
			case 4:
				airLevelName = mdSmart.i18n.AIR_LEVEL_3;
				break;
			case 5:
				airLevelName = mdSmart.i18n.AIR_LEVEL_3;
				break;
		}

		s.airQua = "室内空气质量 " + airLevelName; //pm2.5值

		if (deviceType != "5" && deviceType != "6" && deviceType != "4" && deviceType != "7" && deviceType != "10") {
			s.pmLowValue = airLevelName;
			$('#airQua').css('display', 'none');
		}

		queryNewProtocol();

		initSoundValue();

		init();

	}

	function initMode(modeValue) {
		//var modes = {};
		//if (deviceType == 6 || deviceType == 10) {
		//	modes = {
		//		"1": "自动运行",
		//		"2": "手动运行"
		//	};
		//	modeCount = 2;
		//	$("#modeContainer").css("height","89px");
		//} else {
		//	modes = {
		//		"1": "自动运行",
		//		"2": "手动运行",
		//		"3": "睡眠运行"
		//	};
		//	modeCount = 3;
		//	$("#modeContainer").css("height","135px");
		//}

		var modes = {
			"1": "自动运行",
			"2": "手动运行",
			"3": "睡眠运行"
		}
		modeCount = 3;

		if (s.runStatus == 0) {
			$('#modeText').text("已关机");
		} else {
			//$('#modeText').text(modes[s.mode_FC_return]);
			$('#modeText').text(modes[modeValue]);
		}
	}

	//拷贝controlPanel中代码，更新界面显示
	function init() {

		initMode();
		getSetTimeSec();
		//$('#pmText').text(s.pmLowValue);
		//$('#humidityText').text(s.humidity_cur + '%');
		if(s.indoorTmp == "--")
		{
			$('#indoorTemp').text(s.indoorTmp);
		}
		else{
			$('#indoorTemp').text(s.indoorTmp + "℃");
		}
		if (s.windSpeed > 100) {
			$('#windSpeed').text("风速 自动风");
		} else if (s.windSpeed <= 0) {
			$('#windSpeed').text("风速 --");
		} else {
			$('#windSpeed').text("风速 " + s.windSpeed + '%');
		}
		if (!isNaN(s.windSpeed)) {
			$("#windSlider").slider("value",s.windSpeed);
		}
		$("#windValue").text(s.windSpeed);

		if (s.runStatus == 0) {
			$('#modeText').text("已关机");
			$('#roundBg01').removeClass('cycleZoom01');
			$('#roundBg02').removeClass('cycleZoom02');
			$('#roundBg01').css({
				'opacity': 0.3
			});
			$('#roundBg02').css({
				'opacity': 0.3
			});
			$('#canvasWrap').hide();
			$('#airQua').text(s.airQua);
			$('#t1').css({
				'background-color': 'gray'
			});

			$('#negative').removeClass('selected');
			$("#small-anion").css("display", "none");
			
			//NY机型的负离子功能，实际发送净离子码
			$('#negative2').removeClass('selected');
			$("#small-anion").css("display", "none");

			$('#humidi').removeClass('selected');
			$("#small-humidifier").css("display", "none");

			$('#childrenlock').removeClass('selected');
			$("#small-lock").css("display", "none");

			$('#watericon').removeClass('selected');
			$("#small-netion").css("display", "none");

			$('#atmosphere').removeClass('selected');
			$("#small-light").css("display", "none");

			$('#voiceswitch').removeClass('selected');
			$("#small-sound").css("display", "none");

			$('#timer').removeClass('selected');
			$("#small-timer").css("display", "none");
			
			$("#waterState").css("display", "none");
		} else {
			$('#modeText').text(modes[s.mode_FC_return]);
			$('#roundBg01').addClass('cycleZoom01');
			$('#roundBg02').addClass('cycleZoom02');
			$('#canvasWrap').show();
			$('#airQua').text(s.airQua);
			$('#t1').css({
				'background-color': '#1fba73'
			});

			if (s.ionSetSwitch == '1' && ss.hasIonSetSwitch) {
				$('#negative').addClass('selected');
				$("#small-anion").css("display", "block");
			} else {
				$('#negative').removeClass('selected');
				$("#small-anion").css("display", "none");
			}
			//NY机型负离子功能
			if (deviceType == 5) {
				if (s.waterIcon == '1' && ss.hasIonSetSwitch) {
					$('#negative2').addClass('selected');
					$("#small-anion").css("display", "block");
				} else {
					$('#negative2').removeClass('selected');
					$("#small-anion").css("display", "none");
				}
			}
			if (s.mode_FD_return == '1' && ss.hasHumidity) {
				$('#humidi').addClass('selected');
				$("#small-humidifier").css("display", "block");
			} else {
				$('#humidi').removeClass('selected');
				$("#small-humidifier").css("display", "none");
			}
			if (s.childLock == '1' && ss.hasChildLock) {
				$('#childrenlock').addClass('selected');
				$("#small-lock").css("display", "block");
			} else {
				$('#childrenlock').removeClass('selected');
				$("#small-lock").css("display", "none");
			}
			if (s.waterIcon == '1' && ss.hasWaterIcon) {
				$('#watericon').addClass('selected');
				$("#small-netion").css("display", "block");
			} else {
				$('#watericon').removeClass('selected');
				$("#small-netion").css("display", "none");
			}
			if (s.atmosphere == '0' && ss.hasAtmosphere) {
				$('#atmosphere').addClass('selected');
				$("#small-light").css("display", "block");
			} else {
				$('#atmosphere').removeClass('selected');
				$("#small-light").css("display", "none");
			}
			if (s.voiceswitch == '1' && ss.hasVoiceSwitch) {
				$('#voiceswitch').addClass('selected');
				$("#small-sound").css("display", "block");
			} else {
				$('#voiceswitch').removeClass('selected');
				$("#small-sound").css("display", "none");
			}
			if (s.timingOffSwitch == '1') {
				$('#timer').addClass('selected');
				$("#small-timer").css("display", "block");
			} else {
				$('#timer').removeClass('selected');
				$("#small-timer").css("display", "none");
			}
			if (s.waterState == 0 && ss.hasHumidity && s.mode_FD_return == '1') {
				$("#waterState").css("display", "block");
			} else{
				$("#waterState").css("display", "none");
			}
		}
		$("#amount").val(s.voiceValue);
	}

	function initSoundValue() {
		$("#amount").text(s.voiceValue);
		var voiceNum = (s.voiceValue - 1) * 20 / 3;

		if (s.voiceValue == 15) {
			$(".ui-slider-range").width("100%");
			$(".ui-slider-handle").css('left', "100%");
		} else {
			$(".ui-slider-range").width(voiceNum + "%");
			$(".ui-slider-handle").css('left', voiceNum + "%");
		}
	}

	function initNewProtocol() {
		if (s.voiceType == "0") {
			$('#boySound').removeClass('arrowCheckDisplay');
			$('#girlSound').addClass('arrowCheckDisplay');
		} else {
			$('#boySound').addClass('arrowCheckDisplay');
			$('#girlSound').removeClass('arrowCheckDisplay');
		}
	}

	//查询新协议部分
	function queryNewProtocol() {
		if (deviceType == 5 || deviceType == 6 || deviceType == 10) {
			var tmpCheckTypeCount = 3; //查询属性个数
			var tmpValue = [];
			//
			tmpValue[0] = 0x02; //高位  属性：喇叭声音种类
			tmpValue[1] = 0x0a; //低位

			tmpValue[2] = 0x02; //高位	属性：pm2.5数显
			tmpValue[3] = 0x0b;

			tmpValue[4] = 0x02; //高位 属性：滑动锁
			tmpValue[5] = 0x10;

			var cmdBytes = _dataParse.cmdNewVerForCheck(tmpCheckTypeCount, tmpValue);
			var cmdId = bridge.startCmdProcess(cmdBytes, function(messageBack) {
				receiveNewProtocol(messageBack);
			});
		}
	}

	//收到新协议返回处理
	function receiveNewProtocol(p1) {
		if ((p1[10] == 0xB1) || (p1[10] == 0xB0)) {
			var si = 0;
			var sj = 0;
			var sk = p1[11];

			var tmpCmdType = [];
			var tmpCmdResult = 1;
			var tmpCmdValue = [];

			if (sk > 5) sk = 5;

			for (si = 0; si < sk; si++) {
				tmpCmdResult = p1[14 + si * 5];

				if (tmpCmdResult == 0) {
					tmpCmdType[0] = p1[12 + si * 5];
					tmpCmdType[1] = p1[13 + si * 5];
					var tmpCmdValueLength = p1[15 + si * 5];
					for (sj = 0; sj < tmpCmdValueLength; sj++) {
						tmpCmdValue[sj] = p1[16 + si * 5 + sj];
					}

					explainNewProtocol(tmpCmdType, tmpCmdValueLength, tmpCmdValue);
				} else {
					return;
				}
			}
			initNewProtocol();
		}
	}

	//解析新协议
	function explainNewProtocol(p1, p2, p3) {
		//开启或关闭设备无极风速
		if ((p1[1] == 0x02) && (p1[0] == 0x10)) {
			if (p3[0] == 1) {
				s.windSpeedSwitch = 1;
			} else {
				s.windSpeedSwitch = 0;
			}
		}

		//声音选择 0:女声   1:男声
		if ((p1[1] == 0x02) && (p1[0] == 0x0A)) {
			if (p3[0] == 0) {
				s.voiceType = 0;
			} else if (p3[0] == 1) {
				s.voiceType = 1;
			} else if (p3[0] == 2) {
				s.voiceType = 2;
			} else {
				s.voiceType = 3;
			}
		}

		//PM25数显
		if ((p1[1] == 0x02) && (p1[0] == 0x0B)) {
			if (p3[0] == 1) {
				s.pmDisplay = 1;
			} else {
				s.pmDisplay = 0;
			}
		}
	}


	function airQualityIsInvalid(quality) {
		var qualityIsInvalid = "";
		if (quality == "0") {
			qualityIsInvalid = "32";
		} else if (quality >= "999") {
			qualityIsInvalid = "---";
		} else {
			qualityIsInvalid = quality;
		}
		return qualityIsInvalid;
	};


	//页面切换
	function changePage(nextPage) {
		for (var i = 0; i < appPages.length; i++) {
			if (nextPage == appPages[i]) {
				$("." + nextPage).fadeIn('1000');
			} else {
				$("." + appPages[i]).fadeOut('1000');
			}
		}
	}
	$('.more-setting').click(function(e) {
		e.preventDefault();
		changePage('more-function');
	})

	$('.arrowFilter').click(function(e) {
		e.preventDefault();
		changePage('health-check');
	})

	$('.arrowCommon').click(function(e) {
		e.preventDefault();
		changePage('setting');
	})

	$('.settingBack').click(function(e) {
		e.preventDefault();
		changePage('more-function');
	})

	$('.moreFunctionBack').click(function(e) {
		e.preventDefault();
		changePage('home');
	})

	$('.lightBack').click(function(e) {
		e.preventDefault();
		changePage('setting');
	})

	$('.filterBack').click(function(e) {
		e.preventDefault();
		filterCheckFail();
		$("#filterCheckResult").html("待检测");
		changePage('more-function');
	})

	$('.soundBack').click(function(e) {
		e.preventDefault();
		changePage('setting');
	})

	$('.arrowSetting').click(function(e) {
		e.preventDefault();
		changePage('arrowSound');
	})

	$('.arrowSound').click(function(e) {
		e.preventDefault();
		changePage('sound-control');
	})

	$("#startFilterCheck").click(function() {
		filterCheck();
	})

	$(".fanGeneral").click(function() {
	});

	$(".storeGeneral").click(function() {
	});

	$(".afterSaleGeneral").click(function() {
	});

	//点击按钮绑定事件	filterCheckState:0  开始检测		1  停止检测
	function filterCheck() {
		//		if (filterCheckState == 0) {
		startFilterCheck();
		//		} else {
		//			stopFilterCheck();
		//		}
	}

	//开始滤网检测
	function startFilterCheck() {
		if (filterCheckState == 0) {

			filterCheckState = 1;
			var functionParamers = {
				queryStrings: {
					"serviceUrl": "/filter/TAStartFilter"
				},
				transmitData: {
					"applianceId": tmpApplianceId,
					"type": 2
				}
			};
			$("#filterCheckBg").removeClass("filterCheckingBg").addClass("filterCheckBg");
			$("#filterCheckResult").html("正在检测...");
			$("#filterCanvas").show();
			filterCheckAnimate('filterCanvas');
			

			var cmdId = bridge.requestDataTransmit(functionParamers, function(messageBack) {
				var jsonString = JSON.stringify(messageBack);
				var jsonData = JSON.parse(jsonString);
				var errflag = jsonData.errorCode;
				var result = "";
				if (errflag == 0) {
					var returnData = jsonData.result.returnData;
					var errMsg = returnData.errMsg;
					var errCode = returnData.errCode;
					if (errCode != 0) {
						showMessage(errMsg + "[" + errCode + "]");
						filterCheckFail();
					} else {
						timehandle = window.setTimeout(queryFiterCheckResult, 5000);
					}
				} else {
					showMessage(jsonData.msg + "[" + errflag + "]");
					filterCheckFail();
				}
			});
		}
	}

	//停止滤网检测
	function stopFilterCheck() {
		filterCheckState = 0;
		$("#filterCanvas").hide();
		$("#filterCheckBg").removeClass("filterCheckingBg").addClass("filterCheckBg");
	}

	//查询滤网检测结果
	function queryFiterCheckResult() {
		if (filterCheckState == 1) {
			var functionParamers = {
				queryStrings: {
					"serviceUrl": "/filter/TAQueryFilterResult"
				},
				transmitData: {
					"applianceId": tmpApplianceId,
					"type": 2
				}
			};
			var cmdId = bridge.requestDataTransmit(functionParamers, function(messageBack) {
				var jsonString = JSON.stringify(messageBack);
				var jsonData = JSON.parse(jsonString);
				var errflag = jsonData.errorCode;
				var result = "";

				if (errflag == 0) {
					var returnData = jsonData.result.returnData;
					var errMsg = returnData.errMsg;
					var errCode = returnData.errCode;
					if (errCode != 0) {
						showMessage(errMsg + "[" + errCode + "]");
						filterCheckFail();
					} else {
						var filterStatus = returnData.result.status;
						var filterLevel = returnData.result.level;
						var filterValue = returnData.result.value;
						var filterDesc = returnData.result.description;
						//  1  检测成功   2  检测失败		3  检测中   
						if (filterStatus == 3) {
							$("#filterCheckBg").removeClass("filterCheckingBg").addClass("filterCheckBg");
							timehandle = window.setTimeout(filterQueryResultState, 5000);
						} else if (filterStatus == 1) {
							filterCheckState = 0;
							$("#filterCheckSuggest").html(filterDesc);
							if (filterLevel <= 1) { //干净
								$("#filterCheckResult").html("滤网积尘较少");
								$("#filterCheckBg").removeClass("filterCheckBg").addClass("filterCheckingBg");
							} else if (2 == filterLevel) { //脏
								$("#filterCheckResult").html("滤网积尘较多");
								$("#filterCheckBg").removeClass("filterCheckBg").addClass("filterCheckingBg");
							} else if (3 <= filterLevel) { //严重脏
								$("#filterCheckResult").html("滤网积尘非常多");
								$("#filterCheckBg").removeClass("filterCheckBg").addClass("filterCheckingBg");
							}
							window.clearTimeout(timehandle);
							$("#filterCanvas").hide();
							$("#filterCheckBg").removeClass("filterCheckBg").addClass("filterCheckingBg");
						} else if (filterStatus == 2) {
							filterCheckFail();
						}
					}
				} else {
					filterCheckFail();
					showMessage(jsonData.msg + "[" + errflag + "]");
				}
			});
		}
	}

	//检测失败
	function filterCheckFail() {
		filterCheckState = 0;
		$("#filterCanvas").hide();
		$("#filterCheckBg").removeClass("filterCheckingBg").addClass("filterCheckBg");
		$("#filterCheckResult").html("检测失败");
		window.clearTimeout(timehandle);
	}

	$("#mideaFan").click(function() {
		if (mideaFanUrl == "") {
			requestExternalUrl()
		}
		openMideaFanUrl();
	})

	$("#mideaStore").click(function() {
		if (mideaStoreUrl == "") {
			requestExternalUrl();
		}
		openMideaStoreUrl();
	})

	$("#mideaAfterSale").click(function() {
		if (mideaAfterSaleUrl == "") {
			requestExternalUrl();
		}
		openMideaAfterSaleUrl();
	})

	/**
	 * 获取美粉圈，售后，商城url
	 */
	function requestExternalUrl() {
		var functionParamers = {
			queryStrings: {
				"serviceUrl": "/appliance/getOurterUrlInfo"
			},
			transmitData: {
				"userId": 0,
				"familyId": 0,
				"roomId": "1",
			},
		};
		var cmdId = bridge.requestDataTransmit(functionParamers, function(messageBack) {
			var mideaStoreUrlKey = "shopUrl";
			var mideaAfterSaleUrlKey = "afterSaleUrl";
			var mideaFansUrlKey = "mideaFansUrl"
			var jsonString = JSON.stringify(messageBack);
			var jsonData = JSON.parse(jsonString);
			var errflag = jsonData.errorCode;
			var result = "";
			if (errflag == 0) {
				var returnData = jsonData.result.returnData;
				var errMsg = returnData.errMsg;
				var errCode = returnData.errCode;
				if (errCode == 0) {
					var resultEnv = returnData.result;
					for (var i = 0; i < resultEnv.length; i++) {
						var rItem = resultEnv[i];
						var urlKey = rItem.key;
						if (mideaStoreUrlKey == rItem.key) {
							mideaStoreUrl = rItem.val;
							continue;
						}
						if (mideaAfterSaleUrlKey == rItem.key) {
							mideaAfterSaleUrl = rItem.val;
							continue;
						}
						if (mideaFansUrlKey == rItem.key) {
							mideaFanUrl = rItem.val;
							continue;
						}
					}
				} else {

				}
			} else {

			}
		});
	}

	//打开美粉圈
	function openMideaFanUrl() {
		bridge.openWeb(mideaFanUrl);
	}

	//打开美的商城
	function openMideaStoreUrl() {
		bridge.openWeb(mideaStoreUrl);
	}

	//打开售后服务
	function openMideaAfterSaleUrl() {
		bridge.openWeb(mideaAfterSaleUrl);
	}

	//	获取定时秒数
	function getSetTimeSec() {
		var secValue;
		var sec;
		secValue = 1800;
		sec = s.timingOffHour * 900 + (900 - s.timingOffMinute * 60);
		if (s.runStatus == 0) {
			secValue = 1800;
		} else {
			secValue = compareTime(sec);
		}
		$("#sel").mobiscroll('setVal', secValue, true, true, true, 0);
	}
	
	
	function compareTime( sec ){
		var secPerHalfHour = 1800;
		var timeZone = 0; 
		if(sec == 0 || s.timingOffSwitch == 0){
			timeZone = 1800;
		} else {
			timeZone = Math.ceil(sec/secPerHalfHour) * 1800;
		}
		
		return timeZone;
	}


}